
/*
 * XKOBO, a video-oriented game
 * Copyright (C) 1995,1996  Akira Higuchi
 *     a-higuti@math.hokudai.ac.jp
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef XKOBO_H_XLSCROLL
#define XKOBO_H_XLSCROLL

#include "xlbacking.h"

/*
 *
 *     win_backing  ---- win_scroll ----
 *                   \
 *                    \
 *                   
 */
 
class win_scroll : public win_backing{

  protected:
    int vsx,vsy; /* size of virtual screen */
    int vx,vy;   /* current position */
    
  public:
    win_scroll();
    ~win_scroll();
    void make(win *back, int wx, int wy, int sizex, int sizey,
              int vsizex, int vsizey);
    void clear();
    virtual void expose_backing();                 /* from eventroop() */
    void set_position(int vposx, int vposy);
    void torus();
    inline void back(){
      RECT rs, rd; 
      rs.c.left = vx; rs.c.top = vy; rs.c.right = vx+sx; rs.c.bottom = vy+sy;
      rd.c.left = this->x; rd.c.top = this->y; 
      rd.c.right = this->x + sx; rd.c.bottom = this->y + sy;
      gcop_bmp(p_gc, &rs, w_gc, &rd, NULL, G_STORE);
    }
    inline void back(int x,int y,int h,int v){
      RECT rs, rd; 
      rs.c.left = vx+x; rs.c.top = vy+y; rs.c.right = vx+x+h; rs.c.bottom = vy+y+v;
      rd.c.left = this->x + x; rd.c.top = this->y + y; 
      rd.c.right = this->x + x+h; rd.c.bottom = this->y + y+h;
      gcop_bmp(p_gc, &rs, w_gc, &rd, NULL, G_STORE);
    }
};

#endif // XKOBO_H_XLSCROLL
