
/*
 * XKOBO, a video-oriented game
 * Copyright (C) 1995,1996  Akira Higuchi
 *     a-higuti@math.hokudai.ac.jp
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include <basic.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <btron/dp.h>
#include <btron/hmi.h>
#include <tcode.h>

#include "xevent.h"
#include "xlwin.h"

char       win::disp_string[1024] = {0};
WEVENT     win::xevt;
XEventType win::xevt_type;

//--------------------------------------------------------------------------//
Bool event_predicate(WEVENT *, char *)
{
    return True;
}


//--------------------------------------------------------------------------//
//                     class     win                                        //
//--------------------------------------------------------------------------//

win::win()
{
    mask = 0;
    ecount = 0;
}

win::~win()
{
    if (icon) ; // TODO: XFreePixmap(disp, icon);
    if (w >= 0) {
      wcls_wnd(w, CLR);
    }
}   

void win::make(win *back,int wx,int wy,int sizex,int sizey)
{
    if (mask == -1) return;
    x = wx;
    y = wy;
    sx = sizex;
    sy = sizey;
    this->back = back;

    //XSelectInput(disp,w,mask);
    mask = -1;

    icon = NULL; //XCreateBitmapFromData(disp, w, icon_bitmap, 64, 64);
}

void win::map()
{
    if (back == NULL) {
        TC wtitle_defstr[] = {TK_x, TK_k, TK_o, TK_b, TK_o, TNULL};
        RECT r;
        r.c.left = x+winx; r.c.top = y+winy; 
        r.c.right = r.c.left+sx; r.c.bottom = r.c.top+sy;
        bgpat.spat.kind = 0;
        bgpat.spat.hsize = bgpat.spat.vsize = 1;
        bgpat.spat.fgcol = 0x10000000;
        bgpat.spat.bgcol = 0x10ffffff;
        w = wopn_wnd(wattr, pwid, &r, NULL, 24, 
                     wtitle_defstr, &bgpat, NULL);
    }
    else {
        w = back->w;
    }
}

void win::unmap()
{
    if (back == NULL) {
        wcls_wnd(w, CLR);
        w = -1;
    }
}

void win::title(char *title)
{
    // TODO
}

void win::setowner(void *owner)
{
    ownerobject = owner;
}

void *win::getowner()
{
    return ownerobject;
}

void win::setborder(COLOR color)
{
    bgpat.spat.fgcol = color;
    if (w >= 0) {
        wset_bgp(w, &bgpat);
    }
}

void win::appeal(char *name)
{
    // BTRONǤ̵
}

void win::erase_cursor()
{
    PTRIMG ptrimg;
    bzero(&ptrimg, sizeof(PTRIMG));

    gset_ptr(NULL, &ptrimg, (COLOR)-1, (COLOR)-1);
}
