
/*
 * XKOBO, a video-oriented game
 * Copyright (C) 1995,1996  Akira Higuchi
 *     a-higuti@math.hokudai.ac.jp
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef XKOBO_H_XLWIN
#define XKOBO_H_XLWIN
  
#define EVENTMAX 33

#include <basic.h>
#include <bstring.h>
#include <btron/hmi.h>
#include <btron/dp.h>
#include "xevent.h"

Bool event_predicate(WEVENT *, char *);

class win{

  public:
    WID w;

  protected:
    win *back;
    int x,y,sx,sy;
    long mask;
    int ecount;
    void *ownerobject;
    BMP* icon;
    static char disp_string[1024];
    PAT bgpat;
    int winx, winy;
    UW wattr;
    WID pwid;
    
  public:
    static WEVENT xevt;
    static XEventType xevt_type;
    static inline void set_disp_string(char *t){
        strncpy(disp_string, t, 1024);}
    
    win();
    virtual ~win();
    void make(win *back=NULL,int wx=0,int wy=0,int sizex=200,int sizey=200);
    void map();
    void unmap();
    void title(char *title);
    void erase_cursor();
    void setowner(void *owner);
    void *getowner();
    void appeal(char *name);
    void setborder(COLOR color);
    inline int setwopt(int x, int y, UW attr) { 
        winx = x; winy = y; wattr = attr;
    }
    inline int setparentwid(WID pwid) {
        this->pwid = pwid;
    }
    inline WID getwid() {
        return w;
    }
};

#endif // XKOBO_H_XLWIN
